unit ddetu1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DdeMan, StdCtrls, Spin, ExtCtrls, Clipbrd;

type
  TTestForm = class(TForm)
    ImageLabel: TLabel;
    Label5: TLabel;
    ddeMsgLabel: TLabel;
    btnQuit: TButton;
    ddeClient: TDdeClientConv;
    ddeClientItem: TDdeClientItem;
    Panel1: TPanel;
    testImage: TImage;
    HelpBtn: TButton;
    CommandListBox: TListBox;
    commandEdit: TEdit;
    btnExecuteFunction: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnQuitClick(Sender: TObject);
    procedure ddeClientItemChange(Sender: TObject);
    procedure ddeClientClose(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure CommandListBoxClick(Sender: TObject);
    procedure btnExecuteFunctionClick(Sender: TObject);
  private
    { Private-Deklarationen }
    macroResult   :string;
    lastMacro     :AnsiString;
    macroFinished :boolean;

    procedure sendMacro(macro:AnsiString);
    function getFrameFromClipboard:string;
    function putFrametoClipboard:string;
  public
    { Public-Deklarationen }
  end;

var
  TestForm: TTestForm;

implementation

uses helpdlg;

{$R *.DFM}

procedure TTestForm.FormCreate(Sender: TObject);
begin
 ddeClient.ServiceApplication:= 'pmotion';
 if not ddeClient.SetLink( 'pmotion', 'ImageServer' ) then
    begin
     Application.MessageBox( 'Could not create DDE-connection to host-application!', 'DDE-Error', MB_APPLMODAL or MB_ICONEXCLAMATION or MB_OK );
     halt;
    end;
 ddeClientItem.DdeItem:= 'ImageServerItem';
 macroFinished:=true;
end;

procedure TTestForm.btnQuitClick(Sender: TObject);
begin
 close;
end;

function TTestForm.getFrameFromClipboard:string;
var i: integer;
    imgPtr: Pointer;
    bmpInfo: ^TBitmapInfo;
    logptr: ^TlogPalette;
    HBmp: HBitmap;
    palHandle: HPalette;
begin
 result:='';
 HBmp:= Clipboard.getAsHandle(CF_dib);
 if HBmp=0 then
    begin
     result:='Error while receiving image data!';
     exit;
    end;

 BmpInfo:= globallock( hbmp );
 if BmpInfo = nil then
    begin
     globalunlock( hbmp );
     result:= 'Not enough memory available!';
     exit;
    end;

 if bmpInfo^.bmiHeader.biclrused <> 0 then
    imgPtr:= pointer( dword( BmpInfo ) + bmpInfo^.bmiHeader.bisize + bmpInfo^.bmiHeader.biclrused * sizeof( TRGBQuad ) )
   else
    imgPtr:= pointer( dword( BmpInfo ) + bmpInfo^.bmiHeader.bisize + 256 * sizeof( TRGBQuad ) );

 GetMem( logptr, Sizeof( TLogPalette ) + 255 * Sizeof( TPaletteEntry ) );
 logptr^.palVersion:=$0300;
 logptr^.palNumEntries:=256;
 for i:=0 to 255 do
     begin
      logptr^.palPalEntry[i].peFlags:= 0;
      logptr^.palPalEntry[i].peRed:= bmpInfo^.bmiColors[i].rgbred;
      logptr^.palPalEntry[i].peGreen:= bmpInfo^.bmiColors[i].rgbgreen;
      logptr^.palPalEntry[i].peBlue:= bmpInfo^.bmiColors[i].rgbblue;
     end;
 palHandle:=CreatePalette(logptr^);
 FreeMem(logptr);

 testImage.Canvas.FillRect( Rect( 0, 0, testImage.Width, testImage.Height ) );
 testImage.Picture.Bitmap.Palette:= palHandle;

 StretchDIBits( testImage.Picture.Bitmap.Canvas.Handle,
                0, 0, bmpInfo^.bmiHeader.biWidth, bmpInfo^.bmiHeader.biHeight,
                0,0,bmpInfo^.bmiHeader.biWidth, bmpInfo^.bmiHeader.biHeight, imgPtr,
                BMPInfo^, DIB_RGB_COLORS,SRCCOPY );

 testImage.Refresh;
 globalunlock( hbmp );
end;

function TTestForm.putFrametoClipboard:string;
var ptr: Pointer;
    memoryHandle: THandle;
    bitmapInfoSize: Cardinal;
    imageSize: Cardinal;
begin
 result:='';

 GetDIBSizes( testImage.Picture.Bitmap.Handle, bitmapInfoSize, imageSize );
 memoryHandle:= GlobalAlloc( GMEM_MOVEABLE, BitmapInfoSize + imageSize );
 ptr:= Globallock( memoryHandle );

 if ptr<>nil then
    begin
     GetDIB(testImage.Picture.Bitmap.Handle, testImage.Picture.Bitmap.Palette, TBitmapInfo( ptr^ ), pointer( dword( ptr ) + BitmapInfoSize )^ );
     globalunlock(memoryHandle);

     Clipboard.Open;
     Clipboard.setAsHandle(CF_DIB,memoryHandle);
     Clipboard.Close;
    end
   else
    begin
     MessageBox( 0, 'Not enough memory available!', 'Error', MB_APPLMODAL or MB_OK or MB_ICONEXCLAMATION);
     globalunlock( memoryHandle );
     Globalfree( memoryHandle );
     result:= 'Not enough memory available!';
    end;

 {...}
end;

procedure TTestForm.ddeClientItemChange(Sender: TObject);
var slength:integer;
    s:string;
begin
 s:= ddeclientitem.text;
 ddeMsgLabel.Caption:=s;
 if s='' then exit;
 slength:=length(s);
 if slength>0 then
    while (s[slength]=' ') do
          begin
           setlength(s,slength-1);
           slength:=length(s);
           if slength=0 then break;
          end;
 if uppercase(s)='EXIT' then
    Application.Terminate;

 macroFinished:=true;
 lastMacro:= '';

 macroResult:=s;
end;

procedure TTestForm.sendMacro( macro: AnsiString );
 begin
  if not macroFinished then
     exit;
  Application.Processmessages;

  macro:= AnsiString( AnsiUpperCase( macro ) );

  Screen.Cursor:=crHourGlass;
  macroFinished:=false;

  ddeClient.ExecuteMacro( PAnsiChar( Macro ), false);
  repeat
   Application.Processmessages;
   sleep(20);
  until macroFinished;

  Screen.Cursor:=crDefault;
 end;

procedure TTestForm.ddeClientClose(Sender: TObject);
begin
 macroFinished:=true;
 Application.Terminate;
end;

procedure TTestForm.HelpBtnClick(Sender: TObject);
begin
 HelpForm.Show;
end;

procedure TTestForm.CommandListBoxClick(Sender: TObject);
begin
 CommandEdit.Text:=CommandListBox.Items[CommandListBox.ItemIndex];
end;

procedure TTestForm.btnExecuteFunctionClick(Sender: TObject);
var Msg:string;
    Macro: AnsiString;
begin
 if CommandEdit.Text='' then
    exit;

 macro:= AnsiString( UpperCase( CommandEdit.Text ) );

 if (Macro='RECEIVEFRAME')or(Macro='RECEIVEPALETTE') then
    begin
     msg:=putFrametoClipboard;
     if msg='' then
        sendMacro( macro )
       else
        ShowMessage(msg);
     exit;
    end;

 if (Macro='SENDFRAME')or(Macro='SENDPALETTE') then
    begin
     sendMacro(Macro);
     Msg:=getFrameFromClipboard;
     if Msg<>'' then
        ShowMessage(msg);
     exit;
    end;

 sendMacro( macro );
end;

end.
